<template>
  <v-layout>
    <v-flex>
      <h3>Жалоба - {{task.name}}</h3>
      <v-layout wrap>
        <template v-for="photo in photos ">
          <img :src="photo.url" width="150px" height="150px" alt=""
               :key="photo.index" class="px-1 py-1">
        </template>
      </v-layout>
      <table class="operatorDetailTable text-xs-left mt-4 " width="100%">
        <tr>
          <td style="width: 60%">Подана</td>
          <td style="width: 40%; text-align: right;">
            {{timestampToDateTime(task.createdAt)}}
          </td>
        </tr>
        <tr>
          <td style="width: 60%">Местоположение</td>
          <td style="width: 40%; text-align: right;"><a href="">Нижний Новгород,
            улица Нестерова</a></td>
        </tr>
        <tr>
          <td style="width: 60%">Голосов</td>
          <td style="width: 40%; text-align: right;">
            {{task.followerList.length}}
          </td>
        </tr>
        <tr>
          <td style="width: 60%">Статус</td>
          <td style="width: 40%; text-align: right;">
            {{$t('statuses.'+ task.status)}}
          </td>
        </tr>
      </table>
      <br>
      <v-layout class="align-center">
        <v-btn @click="backTo()" color="secondary">
          <v-icon>keyboard_arrow_left</v-icon>
          Вернуться
        </v-btn>

        <v-spacer></v-spacer>

        <template v-if="user.id !== task.creator.id">
          <v-btn color="success" @click="followToTask">
            Поддержать
          </v-btn>
        </template>
      </v-layout>
    </v-flex>
  </v-layout>
</template>

<script>
  import BaseButton from '@/components/base/Button'
  import moment from 'moment'
  import { mapGetters } from 'vuex'

  /**
   * @name ViewTask
   * @mixes Vue
   */
  export default {
    components: { BaseButton },
    props: ['id'],
    name: 'ViewTask',
    data: () => ({
      task: {
        id: '0001',
        followerList: [],
        status: 'draft',
        creator: {}
      },
      photos: [
        {
          url: 'https://ichef.bbci.co.uk/news/976/cpsprodpb/128C3/production/_103617957_screenshot2018-09-27at17.58.56.png',
          index: 1
        }, {
          url: 'https://ichef.bbci.co.uk/news/976/cpsprodpb/128C3/production/_103617957_screenshot2018-09-27at17.58.56.png',
          index: 2
        }
      ]
    }),
    computed: {
      ...mapGetters(['user'])
    },
    methods: {
      backTo () {
        window.history.back();
      },
      timestampToDateTime (timestamp) {
        if (timestamp !== undefined) {
          return moment.unix(timestamp).format('hh:mm DD.MM.YYYY')
        }
      },
      followToTask () {
        this.$store.dispatch('followToTask', this.task.id)
      },
      estimateTask () {
        this.$store.dispatch('estimateTask', this.task.id).then(task => {
          this.task = task
        })
      }
    },
    async mounted () {
      let taskId = this.$route.params.id;
      if (taskId !== undefined) {
        let foundTask = this.$store.getters.taskId(taskId);
        if (foundTask !== undefined) {
          this.task = foundTask
        } else {
          this.$store.dispatch('getTaskById', taskId).then(task => {
            this.task = task
          })
        }
      }
    }
  }
</script>
